#ifndef ACTIONSETHEADER
#define ACTIONSETHEADER
#include <string>
#include <set>
#include <vector>
#include <valarray>
#include <map>

class ActionSet
{
	friend class Repetoire;

	typedef std::map<std::string,float> attriblisttype;
	typedef std::map<std::string,attriblisttype> animlisttype;

	std::string action;

	animlisttype animlist;

	bool matrixDirty;
	std::valarray<float> matrix;

	std::map<std::string,int> attribMap;
	std::map<int, std::string> animMap;


	void RebuildMatrix();
public:
	ActionSet(const std::string act);
	~ActionSet();
	ActionSet();
	void AddAnim(const std::string & name, std::map<std::string,float> & attribs);
	std::string PickAnim(const std::map<std::string,float> & softc);

	

};



#endif