#ifndef BOXINGSIMHEADER
#define BOXINGSIMHEADER
#include "Scene.h"
#include "TimeStamp.h"
#include "PointLight.h"
#include "Camera.h"
#include "Font.h"
#include "Axis3D.h"
#include "Agent.h"
#include "KeyboardAgent.h"
#include "ReactiveAgent.h"


class BoxingSim : public Scene
{
	TimeStamp initTime;
	TimeStamp lastUpdate;
	TimeStamp animStartTime;

	int updates;

	double renderTime,updateTime,interval;

	Camera theCamera;
	PointLight frontLight,overheadLight;

	void HandleInput();
	float theta,phi,dist; //camera coords
	ReactiveAgent boxer1;
#ifdef TWOREACTIVE
	ReactiveAgent boxer2;
#else
	KeyboardAgent boxer2;
#endif
	float RING_SIZE;

	void CollisionDetection();
	void CheckCollision(const char * b1joint, const char * b2joint,
	                    float radius1, float radius2);
	float JointDistance(const char * b1joint, const char * b2joint);

public:
	BoxingSim();
	~BoxingSim();
	bool Initialize();
	void RenderPersp();
	void RenderOrtho();
	void Update();
};


#endif
