#ifndef INTENTIONGENERATORHEADER
#define INTENTIONGENERATORHEADER

#include <vector>
#include "Enums.h"


// Prevent circular header reference with forward declaration
class Agent;


class IntentionGenerator
{
	Agent * agent;
	std::vector<float> adjustments;
	std::vector<Condition> path;
	std::vector<bool> pathchoices;

	bool EvalCond(Condition cond);
	bool ChoosePath(Condition cond);
	float Facing();
	float InReach();
	float FeelingGood();
	float Incoming();
	float Opening();
	float Cornered();

public:
	IntentionGenerator();
	~IntentionGenerator();
	void Reset();
	void SetAgent(Agent * a);
	Intention GenerateIntention();
	void ScorePath(float score);
	bool WriteProfile(const char * filename);
	bool LoadProfile(const char * filename);

	float GetAdjustment(Condition adj);
};

#endif