#include "TimeStamp.h"

LARGE_INTEGER TimeStamp::timeZero;
LARGE_INTEGER TimeStamp::freq;


void 
TimeStamp::SetTimeZero()
{
	QueryPerformanceCounter(&timeZero);
	QueryPerformanceFrequency(&freq);
}

TimeStamp::TimeStamp()
{
	QueryPerformanceCounter(&time);
}

bool operator<(const TimeStamp & t1, const TimeStamp & t2)
{
	return t1.time.QuadPart < t2.time.QuadPart;
}

void
TimeStamp::Reset()
{
	QueryPerformanceCounter(&time);
}

TimeStamp::~TimeStamp()
{
}
	
double 
TimeStamp::Msec() const
{
	return 1000*(double)(time.QuadPart - timeZero.QuadPart)/freq.QuadPart;
}

double 
TimeStamp::Interval(const TimeStamp & t) const
{
	return (double)(t.time.QuadPart - time.QuadPart)/freq.QuadPart;
}
